-- script for tuning Motorized vehicles
-- V.0.15
-- By Marv63 2020
-- credits to PeterAH for base structure



if g_specializationManager:getSpecializationByName("tuning") == nil then
    g_specializationManager.addSpecialization('tuning', 'tuning', "tuning", Utils.getFilename("tuning.lua", g_currentModDirectory))
end

for vehicleTypeName, vehicleType in pairs(g_vehicleTypeManager.vehicleTypes) do 
    if vehicleType == nil then
    elseif SpecializationUtil.hasSpecialization(tuning, vehicleType.specializations) then
    elseif SpecializationUtil.hasSpecialization(SplineVehicle, vehicleType.specializations) then
    elseif SpecializationUtil.hasSpecialization(Motorized, vehicleType.specializations) then
        g_vehicleTypeManager:addSpecialization(vehicleTypeName, 'tuning')
    else
    end
end

function initNewStoreConfig()
    g_configurationManager:addConfigurationType("tuning", g_i18n:getText("CONFIG_TITLE"), "tuning", nil, nil, nil, ConfigurationUtil.SELECTOR_MULTIOPTION)
	StoreItemUtil.getConfigurationsFromXML = Utils.overwrittenFunction(StoreItemUtil.getConfigurationsFromXML, addNewStoreConfig)    
end

function addNewStoreConfig(xmlFile, superFunc, baseXMLName, baseDir, customEnvironment, isMod, storeItem)
	local configurations = superFunc(xmlFile, baseXMLName, baseDir, customEnvironment, isMod, storeItem)    
    local tPower 
    
    if storeItem ~= nil then
        if storeItem.specs.power == nil then
            tPower = 0
        elseif storeItem.specs.power == "" then
            tPower = 0
        else
            tPower = Utils.getNoNil(tonumber(storeItem.specs.power), 0)
        end
--        if tPower == 0 and configurations == nil then
--            print(storeItem.categoryName)
--        end
        if tPower > 0 then
            if configurations == nil then
                if storeItem.categoryName == "ANIMALPENS" then
                elseif storeItem.categoryName == "PLACEABLEMISC" then
                elseif storeItem.categoryName == "DECORATION" then
                elseif storeItem.categoryName == "FARMHOUSES" then
                elseif storeItem.categoryName == "SILOS" then
                elseif storeItem.categoryName == "WOOD" then
                elseif storeItem.categoryName == "ANIMALS" then
                else
                    configurations = {}
--                    print(configurations .. storeItemXmlFilename)
                end
            end
        end
    end
    
    local integrateConfig = false
    if storeItem == nil then
        elseif configurations == nil then
        elseif configurations["tuning"] ~= nil then
        else
            integrateConfig = true
    end

    if tPower > 0 and integrateConfig == true then
--        print(tPower .. tostring(integrateConfig))

        local cName = {}
        local cCost = {}
        local dUpKeep = {}
    
        configurations["tuning"] = {
            {name = cName[1], index = 1, isDefault = true,  price = cCost[1] , dailyUpkeep = dUpKeep[1], desc = "", configMultiplier = 1.00},
            {name = cName[2], index = 2, isDefault = false, price = cCost[2], dailyUpkeep = dUpKeep[2], desc = "", configMultiplier = 1.05},
            {name = cName[3], index = 3, isDefault = false, price = cCost[3], dailyUpkeep = dUpKeep[3], desc = "", configMultiplier = 1.10},
            {name = cName[4], index = 4, isDefault = false, price = cCost[4], dailyUpkeep = dUpKeep[4], desc = "", configMultiplier = 1.15},
            {name = cName[5], index = 5, isDefault = false, price = cCost[5], dailyUpkeep = dUpKeep[5], desc = "", configMultiplier = 1.20},
            {name = cName[6], index = 6, isDefault = false, price = cCost[6], dailyUpkeep = dUpKeep[6], desc = "", configMultiplier = 1.25},
            {name = cName[7], index = 7, isDefault = false, price = cCost[7], dailyUpkeep = dUpKeep[7], desc = "", configMultiplier = 1.30},
            {name = cName[8], index = 8, isDefault = false, price = cCost[8], dailyUpkeep = dUpKeep[8], desc = "", configMultiplier = 1.35},
            {name = cName[9], index = 9, isDefault = false, price = cCost[9], dailyUpkeep = dUpKeep[9], desc = "", configMultiplier = 1.40},
            {name = cName[10],index = 10,isDefault = false, price = cCost[10], dailyUpkeep = dUpKeep[10], desc = "", configMultiplier = 1.45},
            {name = cName[11],index = 11,isDefault = false, price = cCost[11], dailyUpkeep = dUpKeep[11], desc = "", configMultiplier = 1.50},
            {name = cName[12],index = 12,isDefault = false, price = cCost[12], dailyUpkeep = dUpKeep[12], desc = "", configMultiplier = 1.60},
            {name = cName[13],index = 13,isDefault = false, price = cCost[13], dailyUpkeep = dUpKeep[13], desc = "", configMultiplier = 1.70},
            {name = cName[14],index = 14,isDefault = false, price = cCost[14], dailyUpkeep = dUpKeep[14], desc = "", configMultiplier = 1.80},
            {name = cName[15],index = 15,isDefault = false, price = cCost[15], dailyUpkeep = dUpKeep[15], desc = "", configMultiplier = 1.90},
            {name = cName[16],index = 16,isDefault = false, price = cCost[16], dailyUpkeep = dUpKeep[16], desc = "", configMultiplier = 2.00}
        }
        
        tMotor.i = tMotor.i + 1
        table.insert(tMotor.xmls, tMotor.i, {filename = storeItem.xmlFilename, first = true, oPower = tPower})
        tMotor.xmls[tMotor.i].filename = storeItem.xmlFilename

        local i = 1
        local oPowerPS = tPower
        local powerkW
        local powerPS
        local multiplier
        local vCost = StoreItemUtil.getDefaultPrice(storeItem, storeItem.configurations)
        if i ~= nil then 
            for i = 1, 16, 1  do
                multiplier = configurations["tuning"][i].configMultiplier
                powerPS = math.floor(oPowerPS * multiplier)
                powerkW = math.floor(powerPS / 1.35962)
                cName[i] = "+" .. tostring((multiplier - 1) * 100) .. "%" 
                --(" .. tostring(powerkW) .. "kW/" .. tostring(powerPS) .. g_i18n:getText("CONFIG_HPPOWER") .. ")"
                if i == 1 then
                    cCost[i] = 0
                    dUpKeep[i] = 0
                else
                cCost[i] = tonumber(vCost * (math.log10(i + 1)+0.5) * 0.01) + 2000
                dUpKeep[i] = tonumber(vCost * math.pow(i - 0.8, 2) / 2000)
                end
            end
        end
    end
    
    return configurations
end

tMotor = {}
tMotor.xmls = {}
tMotor.i = 0


function tMotor:update(dt)
    if g_gui.guis.ShopMenu.target.isOpen == true then
        local ii = 0
        for ii = 1, tMotor.i do
            local oPowerPS = tMotor.xmls[ii].oPower 
            if tMotor.xmls[ii].first == true then
                local storeItem = g_storeManager:getItemByXMLFilename(tMotor.xmls[ii].filename)
                if storeItem ~= nil and storeItem.configurations ~= nil then
                    if storeItem.configurations["tuning"] ~= nil and storeItem.configurations["motor"] ~= nil then
                        local i = 1
                        local powerkW
                        local powerPS
                        local vCost = StoreItemUtil.getDefaultPrice(storeItem, storeItem.configurations)
                        for i = 1, 16, 1 do
                            multiplier = storeItem.configurations["tuning"][i].configMultiplier
                            powerPS = math.floor(oPowerPS * multiplier)
                            powerkW = math.floor(powerPS / 1.35962)
                            storeItem.configurations["tuning"][i].name = "+" .. tostring((storeItem.configurations["tuning"][i].configMultiplier - 1 ) * 100) .. "%" 
-- .. "% (" .. tostring(powerkW) .. "kW/" .. tostring(powerPS) .. g_i18n:getText("CONFIG_HPPOWER") .. ")"
                            if i == 1 then
                                storeItem.configurations["tuning"][i].price = 0
                                storeItem.configurations["tuning"][i].dailyUpkeep = 0

                            else
                            storeItem.configurations["tuning"][i].price = tonumber(vCost * (math.log10(i + 1)+0.5) * 0.01 + 2000)
                            storeItem.configurations["tuning"][i].dailyUpkeep = tonumber(vCost * math.pow(i - 0.8, 2) / 2000)
                            end
                            tMotor.xmls[ii].first = false
                        end
                    end
                end
            elseif tMotor.xmls[ii].first == false then
                local storeItem = g_storeManager:getItemByXMLFilename(tMotor.xmls[ii].filename)
                if storeItem ~= nil and storeItem.configurations ~= nil then
                    if storeItem.configurations["tuning"] ~= nil and storeItem.configurations["motor"] ~= nil then
                        local i = 1
                        local powerkW
                        local powerPS
                        local vCost = StoreItemUtil.getDefaultPrice(storeItem, storeItem.configurations)
                        for i = 1, 16, 1 do
                            
                            multiplier = storeItem.configurations["tuning"][i].configMultiplier
                            powerPS = math.floor(oPowerPS * multiplier)
                            powerkW = math.floor(powerPS / 1.35962)
                            storeItem.configurations["tuning"][i].name = "+" .. tostring((storeItem.configurations["tuning"][i].configMultiplier - 1 ) * 100) .. "%"
-- .. "% (" .. tostring(powerkW) .. "kW/" .. tostring(powerPS) .. g_i18n:getText("CONFIG_HPPOWER") .. ")"
                            if i == 1 then
                                storeItem.configurations["tuning"][i].price = 0
                                storeItem.configurations["tuning"][i].dailyUpkeep = 0
                                
                            else
                            storeItem.configurations["tuning"][i].price = tonumber(vCost * (math.log10(i + 1)+0.5) * 0.01 + 2000)
                            storeItem.configurations["tuning"][i].dailyUpkeep = tonumber(vCost * math.pow(i - 0.8, 2) / 2000)                            
                            end
                            
                        end
                    end
                end
            else
            end        
        end
    elseif g_shopConfigScreen.isOpen == true and g_shopConfigScreen.storeItem ~= nil then
        
        local storeItem = g_shopConfigScreen.target.shopConfigScreen.storeItem
        local cScreen = g_shopConfigScreen.target.shopConfigScreen
        if storeItem ~= nil and storeItem.configurations ~= nil then
            if storeItem.configurations["tuning"] ~= nil and storeItem.configurations["motor"] ~= nil then             
                local tConfigId = g_shopConfigScreen.configurations.tuning
                local oPowerPS = Utils.getNoNil(storeItem.configurations["motor"][Utils.getNoNil(g_shopConfigScreen.configurations.motor, 1)].power, storeItem.specs.power) --the get no nil is because giants indexed some of their motor configs.... this also makes it cumbersome to have the correct power shown for this in the original field, so i left it (its only the first harvester and tractor, who wants to tune them anyways?)
                local multiplier = storeItem.configurations["tuning"][tConfigId].configMultiplier
                local powerPS = math.floor(oPowerPS * multiplier)
                local powerkW = math.floor(powerPS / 1.35962)
                local vCost = storeItem.price
                storeItem.configurations["tuning"][tConfigId].name = "+" .. tostring((multiplier - 1 ) * 100) .. "%"
-- .. "% (" .. tostring(powerkW) .. "kW/" .. tostring(powerPS) .. g_i18n:getText("CONFIG_HPPOWER") .. ")"
                if tConfigId == 1 then
                    storeItem.configurations["tuning"][tConfigId].price = 0
                    storeItem.configurations["tuning"][tConfigId].dailyUpkeep = 0
                    storeItem.allowLeasing = true
                    g_shopConfigScreen.target.shopConfigScreen.leaseButton.disabled = false
                else
                    storeItem.configurations["tuning"][tConfigId].price = tonumber(vCost * (math.log10(tConfigId + 1)+0.5) * 0.01 + 2000)
                    storeItem.configurations["tuning"][tConfigId].dailyUpkeep = tonumber(vCost * math.pow(tConfigId - 0.8, 2) / 2000)
                    storeItem.allowLeasing = false
                    g_shopConfigScreen.target.shopConfigScreen.leaseButton.disabled = true
-- this line allows seeing the real power in the intended place by giants, but its always one mouseklick behind... so very confusing and i left it out                    storeItem.specs.power = powerPS
                end
-- list of not working shit to update the name, the original power value and disable the leasing button(it only loses the function, but won´t be invisible only if you reenter the vehicle:
-- as you can see i update all values in the target of the view, so, it should be automaticly be updated on change when you assume that the storeconfigscreen works like other guis, which it seemingly doesn´t or im fucking retardet
--              g_shopConfigStore.updateData()
--              ShopConfigScreen.updateData()
--              g_shopConfigStore.updateDisplay()
--              ShopConfigScreen.updateDisplay()
-- i stoped taking notes but i tried many many more in the script console of the anoying giants debugger
-- since nothing works to update this UI and i tried for aproximatly 20 hours  to let the config name adjust and HP sign on the attributes(this kinda works, but it always lags one klick behind... idk if you got any suggestions let me know, im on pretty much every online Modding comunity known as Marv63. I really got pissed by this. So don´t expect any updates to soon. But there will be updates because its so anoying. I think.
                renderText(0.12, 0.35, 0.02,tostring(g_i18n:getText("STORE_SUCKS_EMERGENCYSOLUTION") .. tostring(powerkW) .. "kW/" .. tostring(powerPS) .. g_i18n:getText("CONFIG_HPPOWER")))
            end
        end
    else
    end
end

if tMotor.active == nil then
	tMotor.active = true
	addModEventListener(tMotor)
end

if g_configurationManager.configurations["tuning"] == nil then
    initNewStoreConfig()
end